<?php
/*
 * Add this to the end of your local.inc of phplib.
 */ 

class DB_Phonebook extends DB_Sql {
  var $Host     = "localhost";             ## 
  var $Database = "phonebook";             ## 
  var $User     = "root";                  ## 
  var $Password = "";              ## Change this to your password
}

class Phonebook_CT_Sql extends CT_Sql {
  var $database_class = "DB_Phonebook";          ## Which database to connect...
  var $database_table = "active_sessions"; ## and find our session data in this table.
}

class Phonebook_Session extends Session {
  var $classname = "Phonebook_Session";

  var $cookiename     = "";                ## defaults to classname
  var $magic          = "changeme";      ## ID seed
  var $mode           = "cookie";          ## We propagate session IDs with cookies
  var $fallback_mode  = "get";
  var $lifetime       = 60;                 ## 0 = do session cookies, else minutes
  var $that_class     = "Phonebook_CT_Sql"; ## name of data storage container
  var $gc_time        = 60;
  var $gc_probability = 5;  
}

class Phonebook_User extends User {
  var $classname = "Phonebook_User";

  var $magic          = "changethis";     ## ID seed
  var $that_class     = "Phonebook_CT_Sql"; ## data storage container
}

class Phonebook_Perm extends Perm {
  var $classname = "Phonebook_Perm";
  
  var $permissions = array(
                            "user"       => 1,
                            "admin"       => 2
                          );

  function perm_invalid($does_have, $must_have) {
    global $perm, $auth, $sess;
    global $_PHPLIB;
    
    include($_PHPLIB["libdir"] . "perminvalid.ihtml");
  }
}

class Phonebook_Auth extends Auth {
  var $classname      = "Phonebook_Auth";

  var $lifetime       =  60;

  var $database_class = "DB_Phonebook";
  var $database_table = "auth_user";
  
  function auth_loginform() {
    global $sess;
    global $_PHPLIB;

    include($_PHPLIB["libdir"] . "loginform.ihtml");
  }
  
  function auth_validatelogin() {
    global $username, $password;

    if(isset($username)) {
      $this->auth["uname"]=$username;        ## This provides access for "loginform.ihtml"
    }
    
    
	$uid = false;
	
    $this->db->query(sprintf("select uid, perms, fullname, email
                                     from %s
                                    where username = '%s'
                                      and password = '%s'",
                          $this->database_table,
                          addslashes($username),
                          addslashes($password)));

    while($this->db->next_record()) {
      $uid = $this->db->f("uid");
      $this->auth["perm"] = $this->db->f("perms");
      $this->auth["fullname"] = $this->db->f("fullname");
      $this->auth["email"]    = $this->db->f("email");
    }
    return $uid;
  }
  function auth_preauth() {
    global $username, $password;

    if(isset($username)) {
      $this->auth["uname"]=$username;        ## This provides access for "loginform.ihtml"
    }
	$uid = false;
	
    $this->db->query(sprintf("select uid, perms, fullname, email
                                     from %s
                                    where username = '%s'
                                      and password = '%s'",
                          $this->database_table,
                          addslashes($username),
                          addslashes($password)));

    while($this->db->next_record()) {
      $uid = $this->db->f("uid");
      $this->auth["uid"] = $uid;
      $this->auth["perm"] = $this->db->f("perms");
      $this->auth["fullname"] = $this->db->f("fullname");
      $this->auth["email"]    = $this->db->f("email");
    }
    return $uid;
  }
}

class Phonebook_Default_Auth extends Phonebook_Auth {
  var $classname = "Phonebook_Default_Auth";
  
  var $nobody    = true;
}

?>
